SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'BarroumeresLaje 5/16/2012 20:57'!
blueGhost

	^Ghost new behaviour: (GhostBehaviour new)! !

!PacManTest methodsFor: 'movements' stamp: 'BarroumeresLaje 5/16/2012 19:50'!
down

^DirectionDown new! !

!PacManTest methodsFor: 'construction block types' stamp: 'BarroumeresLaje 5/16/2012 20:04'!
ghostHouseDoorType

^GhostDoorTile new! !

!PacManTest methodsFor: 'movements' stamp: 'BarroumeresLaje 5/16/2012 19:50'!
left

^DirectionLeft new! !

!PacManTest methodsFor: 'construction block types' stamp: 'BarroumeresLaje 5/16/2012 20:15'!
leftTransporterType

^TransporterTile new! !

!PacManTest methodsFor: 'actors' stamp: 'BarroumeresLaje 5/16/2012 20:57'!
pacman

^Pacman new behaviour: (PacmanBehaviour new)! !

!PacManTest methodsFor: 'movements' stamp: 'BarroumeresLaje 5/16/2012 19:50'!
right

^DirectionRight new! !

!PacManTest methodsFor: 'construction block types' stamp: 'BarroumeresLaje 5/16/2012 19:51'!
spaceType

^SpaceTile new
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'BarroumeresLaje 5/16/2012 19:50'!
up

^DirectionUp new! !

!PacManTest methodsFor: 'construction block types' stamp: 'BarroumeresLaje 5/16/2012 19:45'!
wallType

	^WallTile new! !

Object subclass: #Actor
	instanceVariableNames: 'myBehaviour'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 20:50'!
behaviour
	"comment stating purpose of message"

	| temporary variable names |
 ^myBehaviour! !

!Actor methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 20:50'!
behaviour: aBehaviour
	"comment stating purpose of message"

	| temporary variable names |
myBehaviour:=aBehaviour! !

!Actor methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 19:34'!
position
	"comment stating purpose of message"

	| temporary variable names |
 ^(0@0)! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

Object subclass: #ActorBehaviour
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!ActorBehaviour methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 21:04'!
nextPositionSpaceTileFrom: aPosition withDirection: aDirection

	^aDirection nextPositionFor: aPosition.
! !

!ActorBehaviour methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 21:05'!
nextPositionWallTileFrom: aPosition withDirection: aDirection

	^aPosition 
! !

ActorBehaviour subclass: #GhostBehaviour
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostBehaviour methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 21:12'!
nextPositionDoorTileFrom: aPosition withDirection: aDirection

	^aDirection nextPositionFor: aPosition.
! !

!GhostBehaviour methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 21:08'!
nextPositionTransporterTileFrom: aPosition withDirection: aDirection

	^aPosition .
! !

ActorBehaviour subclass: #PacmanBehaviour
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacmanBehaviour methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 21:08'!
nextPositionDoorTileFrom: aPosition withDirection: aDirection

	^aPosition.
! !

!PacmanBehaviour methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 21:10'!
nextPositionTransporterTileFrom: aPosition withDirection: aDirection

	^(3 @ 10)
! !

Object subclass: #ActorMovingDirection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!ActorMovingDirection methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 19:55'!
nextPositionFor: aPosition

^self subclassResponsibility .! !

ActorMovingDirection subclass: #DirectionDown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!DirectionDown methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 19:55'!
nextPositionFor: aPosition

	^ aPosition + (0 @ -1)

! !

ActorMovingDirection subclass: #DirectionLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!DirectionLeft methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 19:56'!
nextPositionFor: aPosition

	^ aPosition + (-1 @ 0)! !

ActorMovingDirection subclass: #DirectionRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!DirectionRight methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 19:57'!
nextPositionFor: aPosition

	^ aPosition + (1 @ 0)
! !

ActorMovingDirection subclass: #DirectionUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!DirectionUp methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 19:57'!
nextPositionFor: aPosition

	^ aPosition + (0 @ 1)! !

Object subclass: #Tile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

Tile subclass: #GhostDoorTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostDoorTile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 21:11'!
nextPositionFor: anActor going: aDirection

	^anActor behaviour nextPositionDoorTileFrom: anActor position withDirection: aDirection.
! !

Tile subclass: #SpaceTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceTile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 21:05'!
nextPositionFor: anActor going: aDirection

	^anActor behaviour nextPositionSpaceTileFrom: anActor position  withDirection: aDirection.
	
! !

!Tile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 19:46'!
nextPositionFor: anActor going: aDirection
	"comment stating purpose of message"

	| temporary variable names |
	self subclassResponsibility .! !

Tile subclass: #TransporterTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!TransporterTile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 21:09'!
nextPositionFor: anActor going: aDirection


	^anActor behaviour nextPositionTransporterTileFrom: anActor position withDirection: aDirection.
! !

Tile subclass: #WallTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallTile methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 5/16/2012 21:06'!
nextPositionFor: anActor going: aDirection

  ^anActor behaviour nextPositionWallTileFrom: anActor position  withDirection: aDirection.

! !
